#include "stdafx.h"

#include <jenga/include/smoothie/Smoothie.h>

#include <Compiler.h>
#include <Program.h>

#include "../BasicCompiler_Common/common.h"

#ifdef _AMD64_
#include "../BasicCompiler64/opcode.h"
#else
#include "../BasicCompiler32/opcode.h"
#endif


void Diagnose(){
	char temporary[8192];

	{
		///////////////////////////////////////////////////////////////////
		// O[o / [J R[ḧ̃TCY𒲂ׂ
		///////////////////////////////////////////////////////////////////

		extern int GlobalOpBufferSize;
		sprintf(temporary, "%d", GlobalOpBufferSize/1024 );
		trace_for_size( (string)"O[ö̃R[hTCY: " + temporary + "KB" );
		//sprintf(temporary, "%d", (obp-GlobalOpBufferSize)/1024 );
		//trace_for_size( (string)"[J̈̃R[hTCY: " + temporary + "KB" );
		//sprintf(temporary, "%d", obp/1024 );
		//trace_for_size( (string)"R[hTCY: " + temporary + "KB" );
	}

	{
		///////////////////////////////////////////////////////////////////
		// O[o֐ANX\bh̃TCY𒲂ׂ
		///////////////////////////////////////////////////////////////////

		int codeSizeOfGlobalProc = 0;
		int codeSizeOfClassMethod = 0;
		compiler.GetObjectModule().meta.GetUserProcs().Iterator_Reset();
		while( compiler.GetObjectModule().meta.GetUserProcs().Iterator_HasNext() )
		{
			UserProc *pUserProc = compiler.GetObjectModule().meta.GetUserProcs().Iterator_GetNext();
			if( pUserProc->IsCompiled() ){
				if( pUserProc->HasParentClass() ){
					codeSizeOfClassMethod += pUserProc->GetCodeSize();
				}
				else{
					codeSizeOfGlobalProc += pUserProc->GetCodeSize();
				}
			}
		}

		sprintf(temporary, "%d", codeSizeOfGlobalProc/1024 );
		trace_for_size( (string)"O[o֐̃R[hTCY: " + temporary + "KB" );
		sprintf(temporary, "%d", codeSizeOfClassMethod/1024 );
		trace_for_size( (string)"NX\bh̃R[hTCY: " + temporary + "KB" );
	}

	{
		///////////////////////////////////////////////////////////////////
		// EnumɕKvȂ̃R[hTCY𒲂ׂ
		///////////////////////////////////////////////////////////////////
		int codeSizeOfEnum = 0;

		// Ce[^Zbg
		compiler.GetObjectModule().meta.GetClasses().Iterator_Reset();

		while( compiler.GetObjectModule().meta.GetClasses().Iterator_HasNext() ){
			int codeSizeOfClass = 0;

			CClass &objClass = *compiler.GetObjectModule().meta.GetClasses().Iterator_GetNext();

			if( !objClass.IsEnum() ){
				// 񋓌^ȊO͖
				continue;
			}

			// I\bh
			BOOST_FOREACH( const CMethod *pMethod, objClass.GetMethods() ){
				if( pMethod->GetUserProc().IsCompiled() ){
					codeSizeOfClass += pMethod->GetUserProc().GetCodeSize();
				}
			}

			// ÓI\bh
			BOOST_FOREACH( const CMethod *pMethod, objClass.GetStaticMethods() ){
					codeSizeOfClass += pMethod->GetUserProc().GetCodeSize();
			}

			codeSizeOfEnum += codeSizeOfClass;
		}

		sprintf(temporary, "%d", codeSizeOfEnum/1024 );
		trace_for_size( (string)"Enum̃R[hTCY: " + temporary + "KB" );
	}

	trace_for_size( "\n\n" );

	{
		///////////////////////////////////////////////////////////////////
		// NX̃TCY𒲂ׂ
		///////////////////////////////////////////////////////////////////

		// Ce[^Zbg
		compiler.GetObjectModule().meta.GetClasses().Iterator_Reset();

		while( compiler.GetObjectModule().meta.GetClasses().Iterator_HasNext() ){
			int codeSizeOfClass = 0;

			CClass &objClass = *compiler.GetObjectModule().meta.GetClasses().Iterator_GetNext();

			// I\bh
			BOOST_FOREACH( const CMethod *pMethod, objClass.GetMethods() ){
				if( pMethod->GetUserProc().IsCompiled() ){
					codeSizeOfClass += pMethod->GetUserProc().GetCodeSize();
				}
			}

			// ÓI\bh
			BOOST_FOREACH( const CMethod *pMethod, objClass.GetStaticMethods() ){
					codeSizeOfClass += pMethod->GetUserProc().GetCodeSize();
			}

			if( codeSizeOfClass ){
				temporary[0]=0;
				lstrcat( temporary, "------------------------------------------------------------------\n" );
				sprintf( temporary + lstrlen(temporary), "y %s NX̃R[hz\n", objClass.GetName().c_str() );
				sprintf( temporary + lstrlen(temporary), "class code size: %d bytes\n", codeSizeOfClass );
				lstrcat( temporary, "------------------------------------------------------------------\n" );
				lstrcat( temporary, "\n" );
				trace_for_size( temporary );
			}
		}
	}
}
